#ifndef __SCENEENTITY_H
#define __SCENEENTITY_H

#include "glInterface.h"
#include <Cg/cg.h>
#include <Cg/cgGL.h>
#include "common.h"

namespace CHCDemoEngine 
{

class RenderState;


/** Class representing a transformation
*/
class Transformation
{
public:
	
	static CGparameter sModelMatrixParam;

	/** Creates a scene entity.
	*/
	Transformation(Matrix4x4 *trafo);

	~Transformation();
	/** Loads this transformation.
	*/
	void Load(RenderState *state);	
	/** Unloads this transformation
	*/
	void Unload(RenderState *state);
	/** Returns the trafo of this scene entity.
	*/
	inline Matrix4x4 *GetMatrix() const  { return mMatrix; }

protected:

	/// transform matrix 
	Matrix4x4 *mMatrix;
};


}

#endif // __SCENEENTITY_H